/*****************************************************
This program was produced by the
CodeWizardAVR V1.25.1 Evaluation
Automatic Program Generator
 Copyright 1998-2006 Pavel Haiduc, HP InfoTech s.r.l.
http://www.hpinfotech.com

Project : "Polygon" transceiver
Version : 
Date    : 13.08.2006
Author  : Freeware, for evaluation and non-commercial use only
Company : 
Comments:      FIR     .  PLL.
              32.


Chip type           : ATmega8535
Program type        : Application
Clock frequency     : 14,000000 MHz
Memory model        : Small
External SRAM size  : 0
Data Stack size     : 128
*****************************************************/

// CodeVisionAVR C Compiler
// (C) 1998-2003 Pavel Haiduc, HP InfoTech S.R.L.

// I/O registers definitions for the ATmega8535(L)


#pragma used+
sfrb TWBR=0;
sfrb TWSR=1;
sfrb TWAR=2;
sfrb TWDR=3;
sfrb ADCL=4;
sfrb ADCH=5;
sfrw ADCW=4;      // 16 bit access
sfrb ADCSRA=6;
sfrb ADMUX=7;
sfrb ACSR=8;
sfrb UBRRL=9;
sfrb UCSRB=0xa;
sfrb UCSRA=0xb;
sfrb UDR=0xc;
sfrb SPCR=0xd;
sfrb SPSR=0xe;
sfrb SPDR=0xf;
sfrb PIND=0x10;
sfrb DDRD=0x11;
sfrb PORTD=0x12;
sfrb PINC=0x13;
sfrb DDRC=0x14;
sfrb PORTC=0x15;
sfrb PINB=0x16;
sfrb DDRB=0x17;
sfrb PORTB=0x18;
sfrb PINA=0x19;
sfrb DDRA=0x1a;
sfrb PORTA=0x1b;
sfrb EECR=0x1c;
sfrb EEDR=0x1d;
sfrb EEARL=0x1e;
sfrb EEARH=0x1f;
sfrw EEAR=0x1e;   // 16 bit access
sfrb UBRRH=0x20;
sfrb UCSRC=0X20;
sfrb WDTCR=0x21;
sfrb ASSR=0x22;
sfrb OCR2=0x23;
sfrb TCNT2=0x24;
sfrb TCCR2=0x25;
sfrb ICR1L=0x26;
sfrb ICR1H=0x27;
sfrb OCR1BL=0x28;
sfrb OCR1BH=0x29;
sfrw OCR1B=0x28;  // 16 bit access
sfrb OCR1AL=0x2a;
sfrb OCR1AH=0x2b;
sfrw OCR1A=0x2a;  // 16 bit access
sfrb TCNT1L=0x2c;
sfrb TCNT1H=0x2d;
sfrw TCNT1=0x2c;  // 16 bit access
sfrb TCCR1B=0x2e;
sfrb TCCR1A=0x2f;
sfrb SFIOR=0x30;
sfrb OSCCAL=0x31;
sfrb OCDR=0x31;
sfrb TCNT0=0x32;
sfrb TCCR0=0x33;
sfrb MCUCSR=0x34;
sfrb MCUCR=0x35;
sfrb TWCR=0x36;
sfrb SPMCR=0x37;
sfrb TIFR=0x38;
sfrb TIMSK=0x39;
sfrb GIFR=0x3a;
sfrb GICR=0x3b;
sfrb OCR0=0X3c;
sfrb SPL=0x3d;
sfrb SPH=0x3e;
sfrb SREG=0x3f;
#pragma used-

// Interrupt vectors definitions


// Needed by the power management functions (sleep.h)
#asm
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x40
	.EQU __sm_mask=0xB0
	.EQU __sm_powerdown=0x20
	.EQU __sm_powersave=0x30
	.EQU __sm_standby=0xA0
	.EQU __sm_ext_standby=0xB0
	.EQU __sm_adc_noise_red=0x10
	.SET power_ctrl_reg=mcucr
	#endif
#endasm


unsigned int i;
unsigned int flt_x[31] @0x60;    //   (   ,    060)
unsigned int flt_B[31] @0x9E;    //   
unsigned int flt_y[31] @0xE0;    //    
unsigned int flt_B1[31] @0x11E;  //    
unsigned int flt_z @0x160;       //     
unsigned int flt_gain @0x162;    //  
unsigned int sig_peak;           //     
unsigned int trx=0;              //        :  0- ,  =0-  .
unsigned int cw_beep=0;          //     (0-   >0- )
unsigned int cw_pause=0;         //    (>0-   )
unsigned int ddot=250;           //  
unsigned int dash=750;           //  

unsigned int trx_pause=0;     //   
int fgen=512;                    //   (     )
unsigned int frx=512;  //880       //  
int dfrx=1;                      //       (0...1023)


//     2 (Timer 2 output compare interrupt service routine)
// 2   32           -
//     
interrupt [4] void timer2_comp_isr(void)
{

if (trx==0){ ADCSRA|=0x40;};  //  ,     
if (trx_pause==0){
//   ,         trx   :
if (trx>0) 
        {trx--;
        if (cw_beep>0) {cw_beep--; if (OCR1A>0) {OCR1A=0;} else {OCR1A=1023;};};       
        if (cw_pause>0 && cw_beep==0) {cw_pause--;};
        };                      
                  } else { trx_pause--;};
                  
                  

if (dfrx>50){
if ((PINC & 0x02)==0 && frx>192){frx--;};     //     (  1) -   ,      
if ((PINC & 0x04)==0 && frx<1022){frx++;};  //  (  2)-   
dfrx=0;} else {dfrx++;};
if (trx>0) {OCR1B=frx-192;} else {OCR1B=frx;};//      -     500  (1024*500/8000=64)
}   
                    

//      (ADC interrupt service routine)        
//     ,       0
interrupt [15] void adc_isr(void)
{
//register static unsigned char input_index=0;

ADMUX=(0        |0xC0       );  //+input_index;  //      0


//            
//  .    FIR-
//------------------------------------------------------------------------------------

#asm
push R0
push R1
push R2
push R16
push R17
push R18
push R19
push R20
push R21
push R22
push R23
push R24
push R25
push R26
push R27
push R28        ;  
push R29        ;
push R30        ;     

	clr	R22			;Clear avg Low byte
	clr	R23
	clr	R24			;Clear avg Low byte
	clr	R25
	clr	R26			;Clear avg Low byte
	clr	R27
	clr	R28			;Clear avg Low byte
	clr	R29
	clr     R30
mav8_3:	
           

        ldd	R22,Y+2		
	ldd	R23,Y+3		
        std     Y+0, R22
        std     Y+1, R23        
        
  	ldd	R21,Y+63        ;33		        
        
       
        movw    R17:R16, R1:R0

;        sbc     R19, R2
        add     R17, R0
        adc     R18, R1
        adc     R19, R2
       
        adc     R25,R17
        adc     R26,R18
        adc     R27,R19

        inc     R30
             
        brlo    c11
  
 	IN      R23,0x4+1
        
        brlo    no_ovfl2

        brlo    no_ovfl2
       
        ldi     R22, $F0    
        
        sts     $9C, R22        ;$7E, R22
        sts     $9D, R23        ;$7F, R23      


	lsr	R27			;       2
	ror	R26			;
	ror	R25			;
	ror	R24			;
        
        cpi     R28,$08                 ;            ;cpi R28,$08
        brlt    div_cl2
 
        sts     $11D, R25        ;$7F, R23 ;     

        clr     R30                   
        clr     R29
        ldi     R28, $E0       ;      

        ldd	R22,Y+2		
	ldd	R23,Y+3		
        std     Y+0, R22
        std     Y+1, R23        
        
  	ldd	R21,Y+63        ;33		        
        
                
        movw    R17:R16, R1:R0

;        sbc     R19, R2
        add     R17, R0
        adc     R18, R1
        adc     R19, R2
       
        adc     R25,R17
        adc     R26,R18
        adc     R27,R19

        inc     R30
             
        brlo    c13
               
div_cl4:
	lsr	R27			;divide by 2
	ror	R26			;
	ror	R25			;
	ror	R24			;
        
        cpi     R28,$08
        brlt    div_cl4

;        brlo    no_ovfl1
        
;        ldi     R24, $FE
        

        sts     $161, R25               ;$E1, R25        ;$A1, R25

pop R29
pop R28
pop R27
pop R26
pop R25
pop R24
pop R23
pop R22
pop R21
pop R20
pop R19
pop R18
pop R17
pop R16
pop R2
pop R1
pop R0


OCR1A=flt_z;  //  -        
  
}

//   .      (/)
//  / 
void main(void)
{

//   /
//   
//     ,  
// Func7=In Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In 
// State7=T State6=T State5=T State4=T State3=T State2=T State1=T State0=T 
PORTA=0x00;
DDRA=0x00;

//   B
//    3   ,  
//  3 - 
// Func7=In Func6=In Func5=In Func4=In Func3=Out Func2=In Func1=In Func0=In 
// State7=T State6=T State5=T State4=T State3=0 State2=T State1=T State0=T 
PORTB=0x00;
DDRB=0x08;

//   
//  7,6,3,2,1,0 - , 5,4 - 
// Func7=In Func6=In Func5=Out Func4=Out Func3=In Func2=In Func1=In Func0=In 
// State7=T State6=T State5=0 State4=0 State3=P State2=P State1=P State0=P 
PORTC=0xFF; //0C
DDRC=0x18; //3C
        
//   D
//  5,4 -  ( ),  - 
// Func7=In Func6=In Func5=Out Func4=Out Func3=In Func2=In Func1=In Func0=In 
// State7=T State6=T State5=0 State4=0 State3=T State2=T State1=T State0=T 
PORTD=0xFF;
DDRD=0x30;

//   0
//  :  
//  : 14000,000 kHz
// : Normal top=FFh
// OC0 :      
TCCR0=0x19;      
TCNT0=0x00;
OCR0=0x01;     // 14000/(2*(1+OCR))=3,500 MHz   //14000/64(presc)/55(0x37)=3.9773 kHz    1.9886

//   1
//  :  
//  : 14000,000 kHz
// : Fast PWM top=03FFh ( )
// OC1A : Non-Inv.
// OC1B : Inverted
//   : On
//    
//    1 
//   : Off
//      : Off
//      : Off
TCCR1A=0xF3;     
TCCR1B=0x89;            
TCNT1H=0x00;
TCNT1L=0x00;
ICR1H=0x00;
ICR1L=0x00;
OCR1AH=0x00;
OCR1AL=0xFF;
OCR1BH=0x00;
OCR1BL=0xFF;            //14000/1(presc)/1024(fast PWM top=03FFh)=13.672 kHz
    

//   2
// : 32 
// : Normal top=FFh
// OC2 output: Disconnected
ASSR=0x08;      //08;      // Clock source: External Clock  //0x00 -   !!!!!
TCCR2=0x09;     //CTC, no prescaling              //0C;     //04(/64) //CTC no Normal mode, OC2 off, presc=64
TCNT2=0x00;
OCR2=0x06;      //32000/6=5,33kHz Compare Match on 06,    32   6.      

//    ( )
// INT0: Off
// INT1: Off
// INT2: Off
MCUCR=0x00;
MCUCSR=0x00;

//    /
TIMSK=0x80; //  T0  -  ,   2 -   32 

//  
// Analog Comparator: Off ()
// Analog Comparator Input Capture by Timer/Counter 1: Off
ACSR=0x80;
SFIOR=0x00;

//  
//   : ,    AREF
//    ,   
ADMUX=0        |0xC0       ;
ADCSRA=0xDA; //    ,      2
SFIOR&=0x0F; //
SFIOR|=0x70; //

//        FIR-. 
//    /  
// 700/950 Hz;
flt_B[0]=12;
flt_B[1]= 13;
flt_B[2]=16;
flt_B[3]=18;
flt_B[4]= 16;
flt_B[5]=10;
flt_B[6]=6;
flt_B[7]=10;
flt_B[8]= 19;
flt_B[9]=24;
flt_B[10]=19;
flt_B[11]= 7;
flt_B[12]=1;
flt_B[13]=7;
flt_B[14]= 20;
flt_B[15]=27;
flt_B[16]=20;
flt_B[17]=7;
flt_B[18]= 1;
flt_B[19]=7;
flt_B[20]=19;
flt_B[21]= 24;
flt_B[22]=19;
flt_B[23]=10;
flt_B[24]= 6;
flt_B[25]=10;
flt_B[26]=16;
flt_B[27]=18;
flt_B[28]= 16;
flt_B[29]=13;
flt_B[30]=12;

// 700/950 Hz;
flt_B1[0]=12;
flt_B1[1]= 13;
flt_B1[2]=16;
flt_B1[3]=18;
flt_B1[4]= 16;
flt_B1[5]=10;
flt_B1[6]=6;
flt_B1[7]=10;
flt_B1[8]= 19;
flt_B1[9]=24;
flt_B1[10]=19;
flt_B1[11]= 7;
flt_B1[12]=1;
flt_B1[13]=7;
flt_B1[14]= 20;
flt_B1[15]=27;
flt_B1[16]=20;
flt_B1[17]=7;
flt_B1[18]= 1;
flt_B1[19]=7;
flt_B1[20]=19;
flt_B1[21]= 24;
flt_B1[22]=19;
flt_B1[23]=10;
flt_B1[24]= 6;
flt_B1[25]=10;
flt_B1[26]=16;
flt_B1[27]=18;
flt_B1[28]= 16;
flt_B1[29]=13;
flt_B1[30]=12;


//  
flt_gain=8;

//  
#asm("sei")

//,    -    3   LED
PORTC=0xE7;
for (i=0;i<10000;i++) {};
PORTC=0xF7;               //  ,
for (i=0;i<10000;i++) {};
PORTC=0xE7;               //  ...
for (i=0;i<10000;i++) {};
PORTC=0xF7; 
for (i=0;i<10000;i++) {};
PORTC=0xE7;
for (i=0;i<10000;i++) {};
PORTC=0xF7;

//      
cw_pause=0;
cw_beep=0;//      100,      3  LED   . 

//  -    
//     ,          
//  trx    (     ) 

while (1)
      {
//sig_peak=sig_peak-1;
//if (sig_peak<flt_z) {sig_peak=sig_peak+1;} else {sig_peak=sig_peak-1;};
//if (sig_peak<700) {PORTC=0x00; if (flt_gain>6){flt_gain=flt_gain-1;}} else {PORTC=0xFF; if (flt_gain<10) {flt_gain=flt_gain+1;}};


if ((PIND & 0x01)==0 && cw_pause==0) {if (trx==0){ trx_pause=ddot;}; cw_beep=dash; cw_pause=ddot; trx=ddot+dash+ddot+2*dash;}; //else {next_cw_beep=dash;};
if ((PIND & 0x02)==0 && cw_pause==0) {if (trx==0){ trx_pause=ddot;}; cw_beep=ddot; cw_pause=ddot; trx=ddot+ddot+ddot+2*dash;}; //else {next_cw_beep=ddot;}; //&& cw_beep==0 && cw_pause==0

if (cw_beep>0 && trx_pause==0) {PORTC|=0x18; if (DDRB==0x00){DDRB=0x08;}; cw_pause=ddot;} else {PORTC&=0xEF; if (DDRB==0x08 && trx>0){DDRB=0x00;};}; // ,   LED,   -  ( ,  4)
if (trx>0) {PORTC|=0x08;} else {PORTC&=0xF7; if (DDRB==0x00){DDRB=0x08;};}; //   ,       ( ,  3),     -  

      };
} 


